



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【Android】使用属性动画碰到的困惑及讲解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【Android】使用属性动画碰到的困惑及讲解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 13:39:43 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<hr>
<p>属性动画的教程网上已经特别多了，本篇也不打算再去各种详解知识点，主要就是记录题主学习属性动画时的碰到的一些困惑，以及后来自己的理解。如果有人也碰到相似的问题，正好可以一起讨论下。</p>
<hr>
<h1>概要</h1>
<p>本篇主要涉及的知识点包括：</p>
<ol><li>ObjectAnimator</li>
<li>ValueAnimator</li></ol>
<p>老规矩，首先先来看下效果图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/810210/201608/810210-20160806230944747-310543784.gif"></p>
<p>这种折叠/展开，隐藏/显示的动画在很多地方都会有用到，如果再加上使用5.0后引进的Z属性，实现各种酷炫的立体动画就更吸引人了。所以，还是先掌握好这基础的属性动画吧。</p>
<h1>分析</h1>
<p>如果你还对属性动画不太明白，或者没用过ObjectAnimator、ValueAnimator的话，建议先去看下<a href="http://blog.csdn.net/guolin_blog/article/details/43536355" rel="external nofollow noreferrer">郭神的这篇</a>。</p>
<p>从上图很容易可以看出，这需要用到<strong>translationX/Y</strong>属性，即平移的属性。也许你会觉得，这不是很简单吗，不就设置下平移的起止值，动画时长，搞定。</p>
<p>没错，是很简单，就是这么实现的。但其实，对于新手来说，知道怎么做和把它做出来其实还是两码事。题主也还是个初学者，当初也是觉得这很简单啊，然后自己做的时候却出现了各种问题。下面就来讲讲题主做的过程中碰到的一些问题吧。</p>
<h2>1、平移的距离如何确定？</h2>
<p>先来看那个竖直收缩/扩展的效果，每个控件都平移到最底下控件的位置，然后消失。有时候我们的需求就是这样，不要求将控件全部移出屏幕，只移到某个指定位置，然后消失之类的。如果是移出屏幕，那么距离很容易设定，但像这种情况下，我们要如何去设置每个控件应该平移多长的距离呢？</p>
<p>很多博客，在对属性动画介绍时，给出的示例代码都是简单的设置某个具体的数值，然后让我们看效果。但这里还能继续用写死的固定值吗，显然不行，那么就需要我们在代码中动态的来计算两个控件之间的距离，然后再来确定控件应该平移的距离。</p>
<p>经过一番查找，题主找到可以用<strong>View.getLocationOnScreen()</strong>这个方法来实现。</p>
<pre class="prettyprint linenums"><code>    /**<br />
     * 计算两个view的距离<br />
     * @param v1<br />
     * @param v2<br />
     * @return 返回new int[2], [0]横坐标距离，[1]纵坐标的距离<br />
     */<br />
    private int[] calculateWidgetsDistance(View v1, View v2){<br />
        int[] location1 = new int[2];<br />
        int[] location2 = new int[2];<br />
        int[] ret = new int[2];

        v1.getLocationOnScreen(location1);<br />
        v2.getLocationOnScreen(location2);

        ret[0] = Math.abs(location1[0] - location2[0]);<br />
        ret[1] = Math.abs(location1[1] - location2[1]);<br />
        return ret;<br />
    }

</code></pre>
<h2>2、setTranslationX(float translationX) 参数值的含义</h2>
<p>如果我们使用<strong>ValueAnimator</strong>来实现动画效果，那么我们就需要接触到<strong>setTranslationX()</strong>这类方法了，如下：</p>
<pre class="prettyprint linenums"><code>        ValueAnimator animator = ValueAnimator.ofFloat(mView.getTranslationY(),300.0f);<br />
           animator.addUpdateListener(new ValueAnimator.AnimatorUpdateListener() {<br />
                @Override<br />
                public void onAnimationUpdate(ValueAnimator animation) {<br />
                    float value = (float) animation.getAnimatedValue();<br />
                    mView.setTranslationY(value);<br />
                }<br />
         });<br />
       animator.setDuration(1000);<br />
       animator.start();

</code></pre>
<p>那么好，问题来了。上面动画的效果是什么？或者说 <strong>300.0f</strong>代表的是什么含义？</p>
<p>先来说说动画的效果，是将mView从当前位置，沿Y轴平移到Y坐标300的地方？还是从当前位置沿Y正方向平移300？我们看下效果是什么：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/810210/201608/810210-20160806184904122-158657040.gif"></p>
<p>好像是沿Y平移了300，那么真的是这样吗？如果上面代码的效果表示的意思真是从当前位置沿Y平移300，那么当我们再次点击按钮时，应该继续往下移300，不断的点击就不断的往下移才对，但很明显，从上图中我们看出，当再次点击时没有任何动画效果了。所以，上面代码的动画效果显然不是沿Y平移300.</p>
<p>那么到底是什么效果呢？我们来将代码稍微做些改动，先<strong>复制</strong>上面代码，然后把<strong>300.0f改成200.0f</strong>,然后把复制的这个动画绑定到其他按钮（如下图的FAB)上，这样当我们先点击FAB，再点击按钮本身，也就是先启动平移200f动画，再启动平移300f的动画。看看会有什么效果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/810210/201608/810210-20160806184930747-1047286273.gif"></p>
<p>注意看上图里的点击顺序，为了更方便讲解，我们这里标好步骤：</p>
<ol><li>点击FAB时，控件往下平移一段距离</li>
<li>再点击控件本身时，控件继续往下平移一段距离，但比第一次平移的距离短</li>
<li>然后不断点击按钮本身时，没任何动画效果</li>
<li>但是当再点击FAB时，按钮往上平移了</li>
<li>此时再点击按钮本身时，咦！发现有效果了，往下平移了</li>
<li>然后再点击按钮本身发现又没任何效果了。但是再点击FAB时，按钮又往上平移了！发现没有，当按钮处于最底时，点击FAB会将按钮返回到第2个步骤了。</li></ol>
<p>我稍微的对上面那图做些备注，你们就很容易明白为什么是这个动画效果，以及最初那几个问题（300.0f代表什么含义）。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/810210/201608/810210-20160806184832590-996174719.jpg"></p>
<p>明白了没有，<strong>300.0f表示的是相对于控件最初最初位置的一个距离</strong>，因为这里是Y轴平移，所以上面那代码的动画效果就是<strong>将mView控件从当前位置，沿Y轴平移到距离控件最初位置300的地方</strong>。</p>
<p>所以，当我们改动代码后才会有那个效果，因为点击FAB，是将控件平移到距离最初起始位置为200的地方。然后再点击按钮本身时，代码意思是将控件从当前位置平移到距离最初位置300的地方，但此时控件的位置并不是在最初的位置，而是已经经过一次平移，处于距离最初位置200的地方，当前控件要平移到300的地方，只需要再平移100就够了。所以第二次控件下移的距离才会比第一次短。之后的效果就不要我再来讲解了吧，记住300.f和200.0f都是相对于最初位置的距离，然后就可以很好的理解上图的动画了。</p>
<p>花这么多力气说这个，是因为题主觉得，对于初学者来说，要确切的理解参数的含义，这样才可以根据自己想要实现的动画效果来计算需要传递进去的数值是多少。</p>
<p>好了，如果我们现在要实现这样一个动画效果，让控件从当前位置沿Y轴平移到距离最初位置200的地方，那么代码该怎么写？</p>
<pre class="prettyprint linenums"><code>    ValueAnimator animator = ValueAnimator.ofFloat(mView.getTranslationY(),200.0f);<br />
    ...<br />
</code></pre>
<p>现在再来实现，很简单，对吧。那么，再来，如果我们要实现，让控件从当前位置沿Y轴平移200呢？</p>
<pre class="prettyprint linenums"><code>   ValueAnimator animator = ValueAnimator.ofFloat(mView.getTranslationY() , mView.getTranslationY() + 200.0f );<br />
   ... 

</code></pre>
<p>怎么样，想对了吗。注意这里的需求是要相对于当前位置移动200，所以数值要怎么计算明白了吧。</p>
<p>理解了参数的含义，想要实现各种动画效果就更有可能了。以上，均为题主学习中碰到的问题和自己的理解，如果有错误的地方，还望告知，不然误导了别人可就不好了。</p>
<h2>ObjectAnimator</h2>
<p>题主是先接触的ValueAnimator，然后才接触ObjectAnimator的，基本的动画效果用这两个都能实现，而且ObjectAnimator实现起来，比ValueAnimator方便多了，反正题主现在是喜欢用ObjectAnimator就是了。</p>
<p>给你们看下，上面贴出来的代码实现的动画效果，用ObjectAnimator该怎么写：</p>
<pre class="prettyprint linenums"><code>       ObjectAnimator animator = ObjectAnimator.ofFloat(mView,&quot;translationY&quot;,mView.getTranslationY(),300.0f);<br />
       animator.setDuration(1000);<br />
       animator.start();

</code></pre>
<p>一句代码就搞定，简单多了。虽然简单，但也有几点需要注意的，数值的确定问题跟上面一样，上面理解了这里就可以直接用了，就不再多说了。</p>
<p>那么，就只剩下第二个参数<strong>&quot;translationY&quot;</strong>这个问题了。它的作用就是指定要实现的是哪个动画属性，说白点，属性动画就是通过不断修改属性值来达到效果的，这点在上面分析的第二点给出的代码上也可以很容易看出来。</p>
<p>那么，这个属性值到底有哪些，这个字符串的参数可以传递哪些进去？不知道有没有初学者跟题主一样，刚接触时都有这个困惑。</p>
<p>去网上查找，你会发现，很多大神都给列举出了其他一些取值，比如&quot;alpha&quot;、&quot;rotationX/Y&quot;等等，那么这些值是从哪来的呢？可以看一看<a href="http://blog.csdn.net/guolin_blog/article/details/43816093" rel="external nofollow noreferrer">郭神的这一篇</a>。这里就稍微提一下，如果你突然忘记某个动画单词该怎么拼，或者不知道它支不支持使用这个方法，可以利用AS的查看源码方式到View里面去查找一下setXXX()和getXXX()方法，如果有，则支持。</p>
<h1>Github</h1>
<p>最后附上Demo源代码地址，有兴趣可以看看，代码很粗糙，只是为了理解怎么用而写的，大家就忽略掉这个问题吧。</p>
<p><a href="https://github.com/woshidasusu/AnimatorDemo" rel="external nofollow noreferrer">AnimatorDemo:https://github.com/woshidasusu/AnimatorDemo</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwo0l97.html">C&num;~异步编程再续~await与async引起的w3wp&period;exe崩溃－问题友好的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z3g31q.html">C&num;中的继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o023x8.html">excel具有制作甘特图的功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xmgge8.html">ios ViewController 页面跳转</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k122339.html">NotePad&plus;&plus; delphi&sol;Pascal函数过程列表插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w6ykxq.html">php文件上传限制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpdmgxq.html">java基础知识点---size&lpar;&rpar;&comma;length&lpar;&rpar;&comma;length的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp6oo69.html">postman 简单教程-实现简单的接口测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7odppj8.html">ETCD集群安装实验</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w32knq.html">Java&lowbar;框架面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rlm349.html">Android Universal Image Loader java&period;io&period;FileNotFoundException&colon; http&colon;&sol;xxx&sol;lxx&sol;xxxx&period;jpg</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjk5vl9.html">以太坊remix-ide本地环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwe55d8.html">GROUP BY 聚合函数&lpar;max min sum avg count&rpar; 和HAVING的 使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwrypz8.html">thinkphp  error&colon;no database select</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7emdwg9.html">struts的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9022dynq.html">&lbrack;转&rsqb;Maven之（七）pom&period;xml配置文件详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnndykjq.html">【架构师之路】APP架构师必看：面对爆发流量如何进行架构调整</a>
		</li>
						<li><a href="https://www.batexi.com/a/963yojn9.html">网络性能测试工具iperf详细使用图文教程&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9024r3jq.html">xmpp实现的即时通讯聊天（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ew5mx9.html">使用xshell远程登录ubuntu使用vi编辑不能使用删除键方向键</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/495zl5m9.html">Xamarin&period;IOS之快速入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r6rkr9.html">WPF，Silverlight与XAML读书笔记第四十八 - Silverlight网络与通讯</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kkg7r8.html">DeviceOne 竟然做出来如此复杂的App</a>
			</li>
						<li><a href="https://www.batexi.com/a/495zewv9.html">Json序列化之&period;NET开源类库Newtonsoft&period;Json的研究</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8my0y08.html">&lbrack;ACM&lowbar;动态规划&rsqb; Palindrome</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdg2x7q.html">用python语言讲解数据结构与算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdg7wxq.html">CocoaPod问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gzojl8.html">跟我一起云计算（6）&mdash;&mdash;openAPI</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jvwp49.html">CGFloat Float 互转</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwn14lq.html">230行实现一个简单的MVVM</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
